if smlua_text_utils_dialog_get then return end

local romhackOn = false
if romhackOn then return end

--DEFINE_DIALOG has to be formatted weirdly

local function get_curr_character_name()
    if (_G.charSelect.character_get_current_number() == CT_MIKU or _G.charSelect.character_get_current_number() == CT_TETO or _G.charSelect.character_get_current_number() == CT_AKITA) then
        return (_G.charSelect.character_get_current_table(nil, nil).name):gsub("Hatsune ", ""):gsub("Kasane ", ""):gsub(
            "Akita ", "")
    end
end

local function get_curr_character_pronouns(other)
    if (_G.charSelect.character_get_current_number() == CT_MIKU or _G.charSelect.character_get_current_number() == CT_TETO or _G.charSelect.character_get_current_number() == CT_AKITA) then
        if not other then
            return "She"
        else
            return "her"
        end
    end
end

local DEFINE_DIALOG = smlua_text_utils_dialog_replace

local function swap_dialog()
    local currCharsName = get_curr_character_name()
    local currCharsPron = get_curr_character_pronouns()
    local currCharsPron2 = get_curr_character_pronouns(true)
    DEFINE_DIALOG(DIALOG_034, 1, 6, 30, 200, ("Good afternoon. The\
Lakitu Bros., here,\
reporting live from just\
outside the Princess's\
castle.\
\
" .. currCharsName .. " has just arrived\
on the scene, and we'll\
be filming the action live\
as " .. currCharsPron .. " enters the castle\
and pursues the missing\
Power Stars.\
As seasoned cameramen,\
we'll be shooting from the\
recommended angle, but\
you can change the\
camera angle by pressing\
the [C] Buttons.\
If we can't adjust the\
view any further, we'll\
buzz. To take a look at\
the surroundings, stop\
and press [C] Up.\
\
Press [A] to resume play.\
Switch camera modes with\
the [R] Button. Signs along\
the way will review these\
instructions.\
\
For now, reporting live,\
this has been the\
Lakitu Bros."))

    DEFINE_DIALOG(DIALOG_003, 1, 5, 95, 200, ("Thank you, " .. currCharsName .. "! The Big\
Bob-omb is nothing but a\
big dud now! But the\
battle for the castle has\
just begun.\
Other enemies are holding\
the other Power Stars. If\
you recover more Stars,\
you can open new doors\
that lead to new worlds!\
My Bob-omb Buddies are\
waiting for you. Be sure\
to talk to them--they'll\
set up cannons for you."))

    DEFINE_DIALOG(DIALOG_005, 1, 3, 30, 200, ("Hey, " .. currCharsName .. "! Is it true\
that you beat the Big\
Bob-omb? Cool!\
You must be strong. And\
pretty fast. So, how fast\
are you, anyway?\
Fast enough to beat me...\
Koopa the Quick? I don't\
think so. Just try me.\
How about a race to the\
mountaintop, where the\
Big Bob-omb was?\
Whaddya say? When I say\
Go, let the race begin!\
\
Ready....\
\
//Go!////Don't Go"))

    DEFINE_DIALOG(DIALOG_011, 1, 4, 30, 200, ("You've just stepped on\
the Metal Cap Switch!\
The Metal Cap makes\
" .. currCharsName .. " invincible.\
Now Metal Caps will\
pop out of all of the\
green blocks you find.\
\
Would you like to Save?\
\
//Yes////No"))

    DEFINE_DIALOG(DIALOG_012, 1, 4, 30, 200, ("You've just stepped on\
the Vanish Cap Switch.\
The Vanish Cap makes\
" .. currCharsName .. " disappear.\
Now Vanish Caps will pop\
from all of the blue\
blocks you find.\
\
Would you like to Save?\
\
//Yes////No"))

    DEFINE_DIALOG(DIALOG_013, 1, 5, 30, 200, ("You've collected 100\
coins! " .. currCharsName .. " gains more\
power from the castle.\
Do you want to Save?\
//Yes////No"))

    DEFINE_DIALOG(DIALOG_014, 1, 4, 30, 200, ("Wow! Another Power Star!\
" .. currCharsName .. " gains more courage\
from the power of the\
castle.\
Do you want to Save?\
\
//You Bet//Not Now"))

    DEFINE_DIALOG(DIALOG_017, 1, 4, 30, 200, ("I'm the Big Bob-omb, lord\
of all blasting matter,\
king of ka-booms the\
world over!\
How dare you scale my\
mountain? By what right\
do you set foot on my\
imperial mountaintop?\
You may have eluded my\
guards, but you'll never\
escape my grasp...\
\
...and you'll never take\
away my Power Star. I\
hereby challenge you,\
" .. currCharsName .. "!\
If you want the Star I\
hold, you must prove\
yourself in battle.\
\
Can you pick me up from\
the back and hurl me to\
this royal turf? I think\
that you cannot!"))

    DEFINE_DIALOG(DIALOG_020, 1, 6, 95, 150, ("Dear " .. currCharsName .. ":\
Please come to the\
castle. I've baked\
a cake for you.\
Yours truly--\
Princess Toadstool"))

    DEFINE_DIALOG(DIALOG_030, 1, 6, 30, 200, ("Hello! The Lakitu Bros.,\
cutting in with a live\
update on " .. currCharsName .. "'s\
progress. " .. currCharsPron .. "'s about to\
learn a technique for\
sneaking up on enemies.\
The trick is this: " .. currCharsPron .. " has\
to walk very slowly in\
order to walk quietly.\
\
\
\
And wrapping up filming\
techniques reported on\
earlier, you can take a\
look around using [C]> and\
[C]<. Press [C]| to view the\
action from a distance.\
When you can't move the\
camera any farther, the\
buzzer will sound. This is\
the Lakitu Bros.,\
signing off."))

    DEFINE_DIALOG(DIALOG_031, 1, 5, 30, 200, ("No way! You beat me...\
again!! And I just spent\
my entire savings on\
these new Koopa\
Mach 1 Sprint shoes!\
Here, I guess I have to\
hand over this Star to\
the winner of the race.\
Congrats, " .. currCharsName .. "!"))

    DEFINE_DIALOG(DIALOG_033, 1, 6, 30, 200, ("Ciao! You've reached\
Princess Toadstool's\
castle via a warp pipe.\
Using the controller is a\
piece of cake. Press [A] to\
jump and [B] to attack.\
Press [B] to read signs,\
too. Use the Control Stick\
in the center of the\
controller to move " .. currCharsName .. "\
around. Now, head for\
the castle."))

    DEFINE_DIALOG(DIALOG_035, 1, 5, 30, 200, ("There are four camera, or\
[C], Buttons. Press [C]^\
to look around using the\
Control Stick.\
\
You'll usually see " .. currCharsName .. "\
through Lakitu's camera.\
It is the camera\
recommended for normal\
play.\
You can change angles by\
pressing [C]>. If you press\
[R], the view switches to\
" .. currCharsName .. "'s camera, which\
is directly behind " .. currCharsPron2 .. ".\
Press [R] again to return\
to Lakitu's camera. Press\
[C]| to see " .. currCharsName .. " from\
afar, using either\
Lakitu's or " .. currCharsName .. "'s view."))

    DEFINE_DIALOG(DIALOG_036, 1, 5, 30, 200, ("OBSERVATION PLATFORM\
Press [C]^ to take a look\
around. Don't miss\
anything!\
\
Press [R] to switch to\
" .. currCharsName .. "'s camera. It\
always follows " .. currCharsName .. ".\
Press [R] again to switch\
to Lakitu's camera.\
Pause the game and\
switch the mode to fix\
the camera in place while\
holding [R]. Give it a try!"))

    DEFINE_DIALOG(DIALOG_042, 1, 4, 30, 200, ("Caution! Narrow Bridge!\
Cross slowly!\
\
\
You can jump to the edge\
of the cliff and hang on,\
and you can climb off the\
edge if you move slowly.\
When you want to let go,\
either press [Z] or press\
the Control Stick in the\
direction of " .. currCharsName .. "'s back.\
To climb up, press Up on\
the Control Stick. To\
scurry up quickly, press\
the [A] Button."))

    DEFINE_DIALOG(DIALOG_045, 1, 6, 95, 200, ("Whew! I'm just about\
flapped out. You should\
lay off the pasta, " .. currCharsName .. "!\
That's it for now. Press\
[A] to let go. Okay,\
bye byyyyyyeeee!"))

    --guy -> girl
    DEFINE_DIALOG(DIALOG_055, 1, 4, 30, 200, ("Hey-ey, " .. currCharsName .. ", buddy,\
howzit goin'? Step right\
up. You look like a fast\
sleddin' kind of girl.\
I know speed when I see\
it, yes--I'm the\
world champion sledder,\
you know. Whaddya say?\
How about a race?\
Ready...\
\
//Go//// Don't Go"))

    DEFINE_DIALOG(DIALOG_058, 1, 4, 30, 200, ("You found my precious,\
precious baby! Where\
have you been? How can\
I ever thank you, " .. currCharsName .. "?\
Oh, I do have this...\
...Star. Here, take it\
with my eternal\
gratitude."))

    DEFINE_DIALOG(DIALOG_064, 1, 5, 30, 200, ("When you put on the Wing\
Cap that comes from a\
red block, do the Triple\
Jump to soar high into\
the sky.\
Use the Control Stick to\
guide " .. currCharsName .. ". Pull back to\
to fly up, press forward\
to nose down, and press [Z]\
to land."))

    DEFINE_DIALOG(DIALOG_065, 1, 6, 30, 200, ("Swimming Lessons!\
Tap [A] to do the breast\
stroke. If you time the\
taps right, you'll swim\
fast.\
\
Press and hold [A] to do a\
slow, steady flutter kick.\
Press Up on the Control\
Stick to dive, and pull\
back on the stick to head\
for the surface.\
To jump out of the water,\
hold Down on the Control\
Stick, then press [A].\
Easy as pie, right?\
\
\
But remember:\
" .. currCharsName .. " can't breathe under\
the water! Return to the\
surface for air when the\
Power Meter runs low.\
\
And one last thing: You\
can't open doors that\
are underwater."))

    DEFINE_DIALOG(DIALOG_066, 1, 5, 30, 200, ("" .. currCharsName .. ", it's Peach!\
Please be careful! Bowser\
is so wicked! He will try\
to burn you with his\
horrible flame breath.\
Run around behind and\
grab him by the tail with\
the [B] Button. Once you\
grab hold, swing him\
around in great circles.\
Rotate the Control Stick\
to go faster and faster.\
The faster you swing him,\
the farther he'll fly.\
\
Use the [C] Buttons to look\
around, " .. currCharsName .. ". You have\
to throw Bowser into one\
of the bombs in the four\
corners.\
Aim well, then press [B]\
again to launch Bowser.\
Good luck, " .. currCharsName .. "! Our\
fate is in your hands."))

    DEFINE_DIALOG(DIALOG_067, 1, 5, 30, 200, ("Tough luck, " .. currCharsName .. "!\
Princess Toadstool isn't\
here...Gwa ha ha!! Go\
ahead--just try to grab\
me by the tail!\
You'll never be able to\
swing ME around! A wimp\
like you won't throw me\
out of here! Never! Ha!"))

    DEFINE_DIALOG(DIALOG_068, 1, 5, 30, 200, ("It's Lethal Lava Land!\
If you catch fire or fall\
into a pool of flames,\
you'll be hopping mad, but\
don't lose your cool.\
You can still control\
" .. currCharsName .. "--just try to keep\
calm!"))

    DEFINE_DIALOG(DIALOG_074, 1, 5, 30, 200, ("You can grab on to the\
edge of a cliff or ledge\
with your fingertips and\
hang down from it.\
\
To drop from the edge,\
either press the Control\
Stick in the direction of\
" .. currCharsName .. "'s back or press the\
[Z] Button.\
To get up onto the ledge,\
either press Up on the\
Control Stick or press [A]\
as soon as you grab the\
ledge to climb up quickly."))

    DEFINE_DIALOG(DIALOG_075, 1, 5, 30, 200, ("" .. currCharsName .. "!! My castle is in\
great peril. I know that\
Bowser is the cause...and\
I know that only you can\
stop him!\
The doors in the castle\
that have been sealed by\
Bowser can be opened only\
with Star Power.\
\
But there are secret\
paths in the castle,\
paths that Bowser hasn't\
found.\
\
One of those paths is in\
this room, and it holds\
one of the castle's Secret\
Stars!\
\
Find that Secret Star,\
" .. currCharsName .. "! It will help you\
on your quest. Please,\
" .. currCharsName .. ", you have to\
help us!\
Retrieve all of the\
Power Stars in the castle\
and free us from this\
awful prison!\
Please!"))

    DEFINE_DIALOG(DIALOG_076, 1, 6, 30, 200, ("Thanks to the power of\
the Stars, life is\
returning to the castle.\
Please, " .. currCharsName .. ", you have\
to give Bowser the boot!\
\
Here, let me tell you a\
little something about the\
castle. In the room with\
the mirrors, look carefully\
for anything that's not\
reflected in the mirror.\
And when you go to the\
water town, you can flood\
it with a high jump into\
the painting. Oh, by the\
way, look what I found!"))

    DEFINE_DIALOG(DIALOG_082, 1, 4, 30, 200, ("Hold on to your hat! If\
you lose it, you'll be\
injured easily.\
\
If you do lose your Cap,\
you'll have to find it in\
the course where you\
lost it.\
Oh, boy, it's not looking\
good for Peach. She's\
still trapped somewhere\
inside the walls.\
Please, " .. currCharsName .. ", you have\
to help her! Did you know\
that there are enemy\
worlds inside the walls?\
Yup. It's true. Bowser's\
troops are there, too.\
Oh, here, take this. I've\
been keeping it for you."))

    DEFINE_DIALOG(DIALOG_083, 1, 6, 30, 200, ("There's something strange\
about that clock. As you\
jump inside, watch the\
position of the big hand.\
Oh, look what I found!\
Here, " .. currCharsName .. ", catch!"))

    DEFINE_DIALOG(DIALOG_092, 1, 5, 30, 200, ("Pestering me again, are\
you, " .. currCharsName .. "? Can't you see\
that I'm having a merry\
little time, making\
mischief with my minions?\
Now, return those Stars!\
My troops in the walls\
need them! Bwa ha ha!"))

    DEFINE_DIALOG(DIALOG_093, 1, 5, 30, 200, ("" .. currCharsName .. "! You again! Well\
that's just fine--I've\
been looking for something\
to fry with my fire\
breath!\
Your Star Power is\
useless against me!\
Your friends are all\
trapped within the\
walls...\
And you'll never see the\
Princess again!\
Bwa ha ha ha!"))

    DEFINE_DIALOG(DIALOG_116, 1, 5, 95, 200, ("Whaaa....Whaaat?\
Can it be that a\
pipsqueak like you has\
defused the Bob-omb\
king????\
You might be fast enough\
to ground me, but you'll\
have to pick up the pace\
if you want to take King\
Bowser by the tail.\
Methinks my troops could\
learn a lesson from you!\
Here is your Star, as I\
promised, " .. currCharsName .. ".\
\
If you want to see me\
again, select this Star\
from the menu. For now,\
farewell."))

    DEFINE_DIALOG(DIALOG_121, 1, 5, 30, 200, ("Nooo! It can't be!\
You've really beaten me,\
" .. currCharsName .. "?!! I gave those\
troops power, but now\
it's fading away!\
Arrgghh! I can see peace\
returning to the world! I\
can't stand it! Hmmm...\
It's not over yet...\
\
C'mon troops! Let's watch\
the ending together!\
Bwa ha ha!"))

    --pal -> gal
    DEFINE_DIALOG(DIALOG_132, 1, 4, 30, 200, ("Whoa, " .. currCharsName .. ", gal, you\
aren't trying to cheat,\
are you? Shortcuts aren't\
allowed.\
Now, I know that you\
know better. You're\
disqualified! Next time,\
play fair!"))

    DEFINE_DIALOG(DIALOG_136, 1, 6, 30, 200, ("Wow! You've already\
recovered that many\
Stars? Way to go, " .. currCharsName .. "!\
I'll bet you'll have us out\
of here in no time!\
\
Be careful, though.\
Bowser and his band\
wrote the book on bad.\
Take my advice: When you\
need to recover from\
injuries, collect coins.\
Yellow Coins refill one\
piece of the Power Meter,\
Red Coins refill two\
pieces, and Blue Coins\
refill five.\
\
To make Blue Coins\
appear, pound on Blue\
Coin Blocks.\
\
\
\
Also, if you fall from\
high places, you'll\
minimize damage if you\
Pound the Ground as you\
land."))

    DEFINE_DIALOG(DIALOG_137, 1, 6, 30, 200, ("Thanks, " .. currCharsName .. "! The castle\
is recovering its energy\
as you retrieve Power\
Stars, and you've chased\
Bowser right out of here,\
on to some area ahead.\
Oh, by the by, are you\
collecting coins? Special\
Stars appear when you\
collect 100 coins in each\
of the 15 courses!"))

    DEFINE_DIALOG(DIALOG_141, 1, 5, 150, 200, ("You've recovered one of\
the stolen Power Stars!\
Now you can open some of\
the sealed doors in the\
castle.\
Try the Princess's room\
on the second floor and\
the room with the\
painting of Whomp's\
Fortress on Floor 1.\
Bowser's troops are still\
gaining power, so you\
can't give up. Save us,\
" .. currCharsName .. "! Keep searching for\
Stars!"))

    DEFINE_DIALOG(DIALOG_154, 1, 5, 30, 200, ("Hold on to your hat! If\
you lose it, you'll be\
easily injured. If you\
lose it, look for it in the\
course where you lost it.\
Speaking of lost, the\
Princess is still stuck in\
the walls somewhere.\
Please help, " .. currCharsName .. "!\
\
Oh, you know that there\
are secret worlds in the\
walls as well as in the\
paintings, right?"))

    DEFINE_DIALOG(DIALOG_155, 1, 6, 30, 200, ("Thanks to the power of\
the Stars, life is\
returning to the castle.\
Please, " .. currCharsName .. ", you have\
to give Bowser the boot!\
\
Here, let me tell you a\
little something about the\
castle. In the room with\
the mirrors, look carefully\
for anything that's not\
reflected in the mirror.\
And when you go to the\
water town, you can flood\
it with a high jump into\
the painting."))

    DEFINE_DIALOG(DIALOG_161, 1, 4, 30, 200, ("" .. currCharsName .. "!!!\
It that really you???\
It has been so long since\
our last adventure!\
They told me that I might\
see you if I waited here,\
but I'd just about given\
up hope!\
Is it true? Have you\
really beaten Bowser? And\
restored the Stars to the\
castle?\
And saved the Princess?\
I knew you could do it!\
Now I have a very special\
message for you.\
Thanks for playing Super\
Mario 64! This is the\
end of the game, but not\
the end of the fun.\
We want you to keep on\
playing, so we have a\
little something for you.\
We hope that you like it!\
Enjoy!!!\
\
The Super Mario 64 Team"))

    DEFINE_DIALOG(DIALOG_163, 1, 5, 30, 200, ("Noooo! You've really\
beaten me this time,\
" .. currCharsName .. "! I can't stand\
losing to you!\
\
My troops...worthless!\
They've turned over all\
the Power Stars! What?!\
There are 120 in all???\
\
Amazing! There were some\
in the castle that I\
missed??!!\
\
\
Now I see peace\
returning to the world...\
Oooo! I really hate that!\
I can't watch--\
I'm outta here!\
Just you wait until next\
time. Until then, keep\
that Control Stick\
smokin'!\
Buwaa ha ha!"))

    --pal -> gal
    DEFINE_DIALOG(DIALOG_164, 1, 4, 30, 200, ("" .. currCharsName .. "! What's up, gal?\
I haven't been on the\
slide lately, so I'm out\
of shape.\
Still, I'm always up for a\
good race, especially\
against an old sleddin'\
buddy.\
Whaddya say?\
Ready...set...\
\
//Go//// Don't Go"))
end

-- Mario Replacement

local function bakas_dialog_swap(m)
    if _G.charSelectExists then
        if m.playerIndex == 0 then
            for j in pairs(gActiveMods) do
                if gActiveMods[j].incompatible then
                    if gActiveMods[j].incompatible:find("romhack") then
                        romhackOn = true
                    end
                end
            end

            if not romhackOn then
                if (_G.charSelect.character_get_current_number() == CT_MIKU or _G.charSelect.character_get_current_number() == CT_TETO or _G.charSelect.character_get_current_number() == CT_AKITA) then
                    swap_dialog()
                else
                    smlua_text_utils_reset_all()
                end
            end
        end
    end
end
hook_event(HOOK_MARIO_UPDATE, bakas_dialog_swap)
