local SEQ_MIKU_POWERUP = SEQ_COUNT + 16
local SEQ_MIKU_METAL = SEQ_COUNT + 32
local SEQ_MIKU_CREDITS = SEQ_COUNT + 64

smlua_audio_utils_replace_sequence(SEQ_MIKU_CREDITS, 0x25, 80, "MikuCredits")
smlua_audio_utils_replace_sequence(SEQ_MIKU_POWERUP, 0x17, 80, "MikuWing")
smlua_audio_utils_replace_sequence(SEQ_MIKU_METAL, 0x18, 80, "MikuMetal")

local function replace_metal_wing_vanish_seqs(p, seq, l)
    if _G.charSelectExists then
        if _G.charSelect.character_get_current_number() == CT_MIKU or _G.charSelect.character_get_current_number() == CT_TETO or _G.charSelect.character_get_current_number() == CT_AKITA then
            if seq == SEQ_EVENT_POWERUP then
                return SEQ_MIKU_POWERUP
            elseif seq == SEQ_EVENT_METAL_CAP then
                return SEQ_MIKU_METAL
            elseif seq == SEQ_EVENT_CUTSCENE_CREDITS then
                return SEQ_MIKU_CREDITS
            end
        end
    end
end
hook_event(HOOK_ON_SEQ_LOAD, replace_metal_wing_vanish_seqs)

-- Delete this Lua file or move it somewhere else if you want to listen to the original SM64 music while using the Miku and Teto mod.
-- Code by maniscat2
